(* automatically generated *)

open Gny;;

module Gny_prime_map = Map.Make
  ( struct type t=gny_prime
           let  compare=Pervasives.compare
    end
  );;

let walk_pool (pool : proof Gny_prime_map.t)
  (g : proof->gny_prime->proof list) =
  Gny_prime_map.fold
  ( fun x x_proof s ->
      try s @ (g x_proof x)
      with Not_found -> s
  ) pool [];;

let in_pool
    (pool : proof Gny_prime_map.t)
    (x : gny_prime) =
    (Gny_prime_map.find x pool);;

let rec apply_rules_r (old : proof Gny_prime_map.t)
  (proof1 : proof) (f : gny_prime) =
  (
    (* rule T1 *)
    ( match f with
        false, (Is_told(z_p, Not_originated_here(z_x))) ->
          [((false,Is_told(z_p, z_x)), Rule("T1", [proof1]))]
      | _ -> []
    )
    @

    (* rule T1t *)
    ( match f with
        false, (Is_told(z_p, Not_originated_here(z_x))) ->
          []
      | _ -> []
    )
    @

    (* rule T2 *)
    ( match f with
        false, (Is_told(z_p, Pair(z_x, z_y))) ->
          [((false,Is_told(z_p, z_x)), Rule("T2", [proof1]));
          ((false,Is_told(z_p, z_y)), Rule("T2", [proof1]))]
      | _ -> []
    )
    @

    (* rule T2t *)
    ( match f with
        false, (Is_told(z_p, Pair(z_x, z_y))) ->
          []
      | _ -> []
    )
    @

    (* rule T3 *)
    ( match f with
        false, (Is_told(z_p, Encrypt_s(z_x, z_k))) ->
          ( try  let proof2 = in_pool old (false,Possesses(z_p, z_k)) in
            [((false,Is_told(z_p, z_x)), Rule("T3", [proof1; proof2]))]
            with Not_found -> []
          )
      | _ -> []
    )
    @

    (* rule T3t *)
    ( match f with
        false, (Is_told(z_p, Encrypt_s(z_x, z_k))) ->
          [((true,Possesses(z_p, z_k)), Rule("T3t", [proof1]))]
      | _ -> []
    )
    @

    (* rule T4 *)
    ( match f with
        false, (Is_told(z_p, Encrypt_pub(z_x, z_k))) ->
          ( try  let proof2 = in_pool old (false,Possesses(z_p, Private_key(z_k))) in
            [((false,Is_told(z_p, z_x)), Rule("T4", [proof1; proof2]))]
            with Not_found -> []
          )
      | _ -> []
    )
    @

    (* rule T4t *)
    ( match f with
        false, (Is_told(z_p, Encrypt_pub(z_x, z_k))) ->
          [((true,Possesses(z_p, Private_key(z_k))), Rule("T4t", [proof1]))]
      | _ -> []
    )
    @

    (* rule T5 *)
    ( match f with
        false, (Is_told(z_p, Binary_func(z_f,z_x, z_y))) ->
          ( try  let proof2 = in_pool old (false,Possesses(z_p, z_x)) in
            [((false,Is_told(z_p, z_y)), Rule("T5", [proof1; proof2]))]
            with Not_found -> []
          )
      | _ -> []
    )
    @

    (* rule T5t *)
    ( match f with
        false, (Is_told(z_p, Binary_func(z_f,z_x, z_y))) ->
          [((true,Possesses(z_p, z_x)), Rule("T5t", [proof1]))]
      | _ -> []
    )
    @

    (* rule TZ *)
    ( match f with
        false, (Is_told(z_p, Leading_to(z_x, z_y))) ->
          [((false,Is_told(z_p, z_x)), Rule("TZ", [proof1]))]
      | _ -> []
    )
    @

    (* rule TZt *)
    ( match f with
        false, (Is_told(z_p, Leading_to(z_x, z_y))) ->
          []
      | _ -> []
    )
    @

    (* rule P1 *)
    ( match f with
        false, (Is_told(z_p, z_x)) ->
          [((false,Possesses(z_p, z_x)), Rule("P1", [proof1]))]
      | _ -> []
    )
    @

    (* rule P1t *)
    ( match f with
        false, (Is_told(z_p, z_x)) ->
          []
      | _ -> []
    )
    @

    (* rule P2 *)
    ( match f with
        true, (Possesses(z_p, Pair(z_x, z_y))) ->
          ( try  let proof2 = in_pool old (false,Possesses(z_p, z_x))
                 and proof3 = in_pool old (false,Possesses(z_p, z_y)) in
            [((false,Possesses(z_p, Pair(z_x, z_y))), Rule("P2", [proof1; proof2; proof3]))]
            with Not_found -> []
          )
      | _ -> []
    )
    @

    (* rule P2b *)
    ( match f with
        true, (Possesses(z_p, Pair(z_x, z_y))) ->
          [((true,Possesses(z_p, z_x)), Rule("P2b", [proof1]));
          ((true,Possesses(z_p, z_y)), Rule("P2b", [proof1]))]
      | _ -> []
    )
    @

    (* rule P2 *)
    ( match f with
        true, (Possesses(z_p, Binary_func(z_f,z_x, z_y))) ->
          ( try  let proof2 = in_pool old (false,Possesses(z_p, z_x))
                 and proof3 = in_pool old (false,Possesses(z_p, z_y)) in
            [((false,Possesses(z_p, Binary_func(z_f,z_x, z_y))), Rule("P2", [proof1; proof2; proof3]))]
            with Not_found -> []
          )
      | _ -> []
    )
    @

    (* rule P2b *)
    ( match f with
        true, (Possesses(z_p, Binary_func(z_f,z_x, z_y))) ->
          [((true,Possesses(z_p, z_x)), Rule("P2b", [proof1]));
          ((true,Possesses(z_p, z_y)), Rule("P2b", [proof1]))]
      | _ -> []
    )
    @

    (* rule P3 *)
    ( match f with
        false, (Possesses(z_p, Pair(z_x, z_y))) ->
          [((false,Possesses(z_p, z_x)), Rule("P3", [proof1]));
          ((false,Possesses(z_p, z_y)), Rule("P3", [proof1]))]
      | _ -> []
    )
    @

    (* rule P3t *)
    ( match f with
        false, (Possesses(z_p, Pair(z_x, z_y))) ->
          []
      | _ -> []
    )
    @

    (* rule P4 *)
    ( match f with
        true, (Possesses(z_p, Unary_func(z_h,z_x))) ->
          ( try  let proof2 = in_pool old (false,Possesses(z_p, z_x)) in
            [((false,Possesses(z_p, Unary_func(z_h,z_x))), Rule("P4", [proof1; proof2]))]
            with Not_found -> []
          )
      | _ -> []
    )
    @

    (* rule P4b *)
    ( match f with
        true, (Possesses(z_p, Unary_func(z_h,z_x))) ->
          [((true,Possesses(z_p, z_x)), Rule("P4b", [proof1]))]
      | _ -> []
    )
    @

    (* rule P5 *)
    ( match f with
        false, (Possesses(z_p, Binary_func(z_f,z_x, z_y))) ->
          ( try  let proof2 = in_pool old (false,Possesses(z_p, z_x)) in
            [((false,Possesses(z_p, z_y)), Rule("P5", [proof1; proof2]))]
            with Not_found -> []
          )
      | _ -> []
    )
    @

    (* rule P5t *)
    ( match f with
        false, (Possesses(z_p, Binary_func(z_f,z_x, z_y))) ->
          [((true,Possesses(z_p, z_x)), Rule("P5t", [proof1]))]
      | _ -> []
    )
    @

    (* rule P6 *)
    ( match f with
        true, (Possesses(z_p, Encrypt_s(z_x, z_k))) ->
          ( try  let proof2 = in_pool old (false,Possesses(z_p, z_x))
                 and proof3 = in_pool old (false,Possesses(z_p, z_k)) in
            [((false,Possesses(z_p, Encrypt_s(z_x, z_k))), Rule("P6", [proof1; proof2; proof3]))]
            with Not_found -> []
          )
      | _ -> []
    )
    @

    (* rule P6b *)
    ( match f with
        true, (Possesses(z_p, Encrypt_s(z_x, z_k))) ->
          [((true,Possesses(z_p, z_x)), Rule("P6b", [proof1]));
          ((true,Possesses(z_p, z_k)), Rule("P6b", [proof1]))]
      | _ -> []
    )
    @

    (* rule P6 *)
    ( match f with
        true, (Possesses(z_p, Decrypt_s(z_x, z_k))) ->
          ( try  let proof2 = in_pool old (false,Possesses(z_p, z_x))
                 and proof3 = in_pool old (false,Possesses(z_p, z_k)) in
            [((false,Possesses(z_p, Decrypt_s(z_x, z_k))), Rule("P6", [proof1; proof2; proof3]))]
            with Not_found -> []
          )
      | _ -> []
    )
    @

    (* rule P6b *)
    ( match f with
        true, (Possesses(z_p, Decrypt_s(z_x, z_k))) ->
          [((true,Possesses(z_p, z_x)), Rule("P6b", [proof1]));
          ((true,Possesses(z_p, z_k)), Rule("P6b", [proof1]))]
      | _ -> []
    )
    @

    (* rule P6' *)
    ( match f with
        false, (Possesses(z_p, Encrypt_s(z_x, z_k))) ->
          ( try  let proof2 = in_pool old (false,Possesses(z_p, z_k)) in
            [((false,Possesses(z_p, z_x)), Rule("P6'", [proof1; proof2]))]
            with Not_found -> []
          )
      | _ -> []
    )
    @

    (* rule P6't *)
    ( match f with
        false, (Possesses(z_p, Encrypt_s(z_x, z_k))) ->
          [((true,Possesses(z_p, z_k)), Rule("P6't", [proof1]))]
      | _ -> []
    )
    @

    (* rule P7 *)
    ( match f with
        true, (Possesses(z_p, Encrypt_pub(z_x, z_k))) ->
          ( try  let proof2 = in_pool old (false,Possesses(z_p, Public_key(z_k)))
                 and proof3 = in_pool old (false,Possesses(z_p, z_x)) in
            [((false,Possesses(z_p, Encrypt_pub(z_x, z_k))), Rule("P7", [proof1; proof2; proof3]))]
            with Not_found -> []
          )
      | _ -> []
    )
    @

    (* rule P7b *)
    ( match f with
        true, (Possesses(z_p, Encrypt_pub(z_x, z_k))) ->
          [((true,Possesses(z_p, Public_key(z_k))), Rule("P7b", [proof1]));
          ((true,Possesses(z_p, z_x)), Rule("P7b", [proof1]))]
      | _ -> []
    )
    @

    (* rule P8 *)
    ( match f with
        true, (Possesses(z_p, Encrypt_priv(z_x, z_k))) ->
          ( try  let proof2 = in_pool old (false,Possesses(z_p, Private_key(z_k)))
                 and proof3 = in_pool old (false,Possesses(z_p, z_x)) in
            [((false,Possesses(z_p, Encrypt_priv(z_x, z_k))), Rule("P8", [proof1; proof2; proof3]))]
            with Not_found -> []
          )
      | _ -> []
    )
    @

    (* rule P8b *)
    ( match f with
        true, (Possesses(z_p, Encrypt_priv(z_x, z_k))) ->
          [((true,Possesses(z_p, Private_key(z_k))), Rule("P8b", [proof1]));
          ((true,Possesses(z_p, z_x)), Rule("P8b", [proof1]))]
      | _ -> []
    )
    @

    (* rule P8' *)
    ( match f with
        false, (Possesses(z_p, Encrypt_pub(z_x, z_k))) ->
          ( try  let proof2 = in_pool old (false,Possesses(z_p, Private_key(z_k))) in
            [((false,Possesses(z_p, z_x)), Rule("P8'", [proof1; proof2]))]
            with Not_found -> []
          )
      | _ -> []
    )
    @

    (* rule P8't *)
    ( match f with
        false, (Possesses(z_p, Encrypt_pub(z_x, z_k))) ->
          [((true,Possesses(z_p, Private_key(z_k))), Rule("P8't", [proof1]))]
      | _ -> []
    )
    @

    (* rule F1 *)
    ( match f with
        true, (Believes(z_p, Fresh(Pair(z_x, z_y)))) ->
          ( try  let proof2 = in_pool old (false,Believes(z_p, Fresh(z_x))) in
            [((false,Believes(z_p, Fresh(Pair(z_x, z_y)))), Rule("F1", [proof1; proof2]))]
            with Not_found -> []
          )
      | _ -> []
    )
    @

    (* rule F1b *)
    ( match f with
        true, (Believes(z_p, Fresh(Pair(z_x, z_y)))) ->
          [((true,Believes(z_p, Fresh(z_x))), Rule("F1b", [proof1]))]
      | _ -> []
    )
    @

    (* rule F1 *)
    ( match f with
        true, (Believes(z_p, Fresh(Pair(z_y, z_x)))) ->
          ( try  let proof2 = in_pool old (false,Believes(z_p, Fresh(z_x))) in
            [((false,Believes(z_p, Fresh(Pair(z_y, z_x)))), Rule("F1", [proof1; proof2]))]
            with Not_found -> []
          )
      | _ -> []
    )
    @

    (* rule F1b *)
    ( match f with
        true, (Believes(z_p, Fresh(Pair(z_y, z_x)))) ->
          [((true,Believes(z_p, Fresh(z_x))), Rule("F1b", [proof1]))]
      | _ -> []
    )
    @

    (* rule F1 *)
    ( match f with
        true, (Believes(z_p, Fresh(Unary_func(z_f,z_x)))) ->
          ( try  let proof2 = in_pool old (false,Believes(z_p, Fresh(z_x))) in
            [((false,Believes(z_p, Fresh(Unary_func(z_f,z_x)))), Rule("F1", [proof1; proof2]))]
            with Not_found -> []
          )
      | _ -> []
    )
    @

    (* rule F1b *)
    ( match f with
        true, (Believes(z_p, Fresh(Unary_func(z_f,z_x)))) ->
          [((true,Believes(z_p, Fresh(z_x))), Rule("F1b", [proof1]))]
      | _ -> []
    )
    @

    (* rule F2 *)
    ( match f with
        true, (Believes(z_p, Fresh(Encrypt_s(z_x, z_k)))) ->
          ( try  let proof2 = in_pool old (false,Believes(z_p, Fresh(z_x)))
                 and proof3 = in_pool old (false,Possesses(z_p, z_k)) in
            [((false,Believes(z_p, Fresh(Encrypt_s(z_x, z_k)))), Rule("F2", [proof1; proof2; proof3]))]
            with Not_found -> []
          )
      | _ -> []
    )
    @

    (* rule F2b *)
    ( match f with
        true, (Believes(z_p, Fresh(Encrypt_s(z_x, z_k)))) ->
          [((true,Believes(z_p, Fresh(z_x))), Rule("F2b", [proof1]));
          ((true,Possesses(z_p, z_k)), Rule("F2b", [proof1]))]
      | _ -> []
    )
    @

    (* rule F2 *)
    ( match f with
        true, (Believes(z_p, Fresh(Decrypt_s(z_x, z_k)))) ->
          ( try  let proof2 = in_pool old (false,Believes(z_p, Fresh(z_x)))
                 and proof3 = in_pool old (false,Possesses(z_p, z_k)) in
            [((false,Believes(z_p, Fresh(Decrypt_s(z_x, z_k)))), Rule("F2", [proof1; proof2; proof3]))]
            with Not_found -> []
          )
      | _ -> []
    )
    @

    (* rule F2b *)
    ( match f with
        true, (Believes(z_p, Fresh(Decrypt_s(z_x, z_k)))) ->
          [((true,Believes(z_p, Fresh(z_x))), Rule("F2b", [proof1]));
          ((true,Possesses(z_p, z_k)), Rule("F2b", [proof1]))]
      | _ -> []
    )
    @

    (* rule F2' *)
    ( match f with
        false, (Believes(z_p, Fresh(Encrypt_s(z_x, z_k)))) ->
          ( try  let proof2 = in_pool old (false,Possesses(z_p, z_k)) in
            [((false,Believes(z_p, Fresh(z_x))), Rule("F2'", [proof1; proof2]))]
            with Not_found -> []
          )
      | _ -> []
    )
    @

    (* rule F2't *)
    ( match f with
        false, (Believes(z_p, Fresh(Encrypt_s(z_x, z_k)))) ->
          [((true,Possesses(z_p, z_k)), Rule("F2't", [proof1]))]
      | _ -> []
    )
    @

    (* rule F3 *)
    ( match f with
        true, (Believes(z_p, Fresh(Encrypt_pub(z_x, z_k)))) ->
          ( try  let proof2 = in_pool old (false,Believes(z_p, Fresh(z_x)))
                 and proof3 = in_pool old (false,Possesses(z_p, Public_key(z_k))) in
            [((false,Believes(z_p, Fresh(Encrypt_pub(z_x, z_k)))), Rule("F3", [proof1; proof2; proof3]))]
            with Not_found -> []
          )
      | _ -> []
    )
    @

    (* rule F3b *)
    ( match f with
        true, (Believes(z_p, Fresh(Encrypt_pub(z_x, z_k)))) ->
          [((true,Believes(z_p, Fresh(z_x))), Rule("F3b", [proof1]));
          ((true,Possesses(z_p, Public_key(z_k))), Rule("F3b", [proof1]))]
      | _ -> []
    )
    @

    (* rule F4 *)
    ( match f with
        true, (Believes(z_p, Fresh(Encrypt_priv(z_x, z_k)))) ->
          ( try  let proof2 = in_pool old (false,Believes(z_p, Fresh(z_x)))
                 and proof3 = in_pool old (false,Possesses(z_p, Private_key(z_k))) in
            [((false,Believes(z_p, Fresh(Encrypt_priv(z_x, z_k)))), Rule("F4", [proof1; proof2; proof3]))]
            with Not_found -> []
          )
      | _ -> []
    )
    @

    (* rule F4b *)
    ( match f with
        true, (Believes(z_p, Fresh(Encrypt_priv(z_x, z_k)))) ->
          [((true,Believes(z_p, Fresh(z_x))), Rule("F4b", [proof1]));
          ((true,Possesses(z_p, Private_key(z_k))), Rule("F4b", [proof1]))]
      | _ -> []
    )
    @

    (* rule F4' *)
    ( match f with
        false, (Believes(z_p, Fresh(Encrypt_pub(z_x, z_k)))) ->
          ( try  let proof2 = in_pool old (false,Possesses(z_p, Private_key(z_k))) in
            [((false,Believes(z_p, Fresh(z_x))), Rule("F4'", [proof1; proof2]))]
            with Not_found -> []
          )
      | _ -> []
    )
    @

    (* rule F4't *)
    ( match f with
        false, (Believes(z_p, Fresh(Encrypt_pub(z_x, z_k)))) ->
          [((true,Possesses(z_p, Private_key(z_k))), Rule("F4't", [proof1]))]
      | _ -> []
    )
    @

    (* rule F5 *)
    ( match f with
        false, (Believes(z_p, Fresh(Public_key(z_k)))) ->
          [((false,Believes(z_p, Fresh(Private_key(z_k)))), Rule("F5", [proof1]))]
      | _ -> []
    )
    @

    (* rule F6 *)
    ( match f with
        false, (Believes(z_p, Fresh(Private_key(z_k)))) ->
          [((false,Believes(z_p, Fresh(Public_key(z_k)))), Rule("F6", [proof1]))]
      | _ -> []
    )
    @

    (* rule F7 *)
    ( match f with
        true, (Believes(z_p, Fresh(Encrypt_s(z_x, z_k)))) ->
          ( try  let proof2 = in_pool old (false,Believes(z_p, Recognizable(z_x)))
                 and proof3 = in_pool old (false,Believes(z_p, Fresh(z_k)))
                 and proof4 = in_pool old (false,Possesses(z_p, z_k)) in
            [((false,Believes(z_p, Fresh(Encrypt_s(z_x, z_k)))), Rule("F7", [proof1; proof2; proof3; proof4]))]
            with Not_found -> []
          )
      | _ -> []
    )
    @

    (* rule F7b *)
    ( match f with
        true, (Believes(z_p, Fresh(Encrypt_s(z_x, z_k)))) ->
          [((true,Believes(z_p, Recognizable(z_x))), Rule("F7b", [proof1]));
          ((true,Believes(z_p, Fresh(z_k))), Rule("F7b", [proof1]));
          ((true,Possesses(z_p, z_k)), Rule("F7b", [proof1]))]
      | _ -> []
    )
    @

    (* rule F7 *)
    ( match f with
        true, (Believes(z_p, Fresh(Decrypt_s(z_x, z_k)))) ->
          ( try  let proof2 = in_pool old (false,Believes(z_p, Recognizable(z_x)))
                 and proof3 = in_pool old (false,Believes(z_p, Fresh(z_k)))
                 and proof4 = in_pool old (false,Possesses(z_p, z_k)) in
            [((false,Believes(z_p, Fresh(Decrypt_s(z_x, z_k)))), Rule("F7", [proof1; proof2; proof3; proof4]))]
            with Not_found -> []
          )
      | _ -> []
    )
    @

    (* rule F7b *)
    ( match f with
        true, (Believes(z_p, Fresh(Decrypt_s(z_x, z_k)))) ->
          [((true,Believes(z_p, Recognizable(z_x))), Rule("F7b", [proof1]));
          ((true,Believes(z_p, Fresh(z_k))), Rule("F7b", [proof1]));
          ((true,Possesses(z_p, z_k)), Rule("F7b", [proof1]))]
      | _ -> []
    )
    @

    (* rule F8 *)
    ( match f with
        true, (Believes(z_p, Fresh(Encrypt_pub(z_x, z_k)))) ->
          ( try  let proof2 = in_pool old (false,Believes(z_p, Recognizable(z_x)))
                 and proof3 = in_pool old (false,Believes(z_p, Fresh(Public_key(z_k))))
                 and proof4 = in_pool old (false,Possesses(z_p, Public_key(z_k))) in
            [((false,Believes(z_p, Fresh(Encrypt_pub(z_x, z_k)))), Rule("F8", [proof1; proof2; proof3; proof4]))]
            with Not_found -> []
          )
      | _ -> []
    )
    @

    (* rule F8b *)
    ( match f with
        true, (Believes(z_p, Fresh(Encrypt_pub(z_x, z_k)))) ->
          [((true,Believes(z_p, Recognizable(z_x))), Rule("F8b", [proof1]));
          ((true,Believes(z_p, Fresh(Public_key(z_k)))), Rule("F8b", [proof1]));
          ((true,Possesses(z_p, Public_key(z_k))), Rule("F8b", [proof1]))]
      | _ -> []
    )
    @

    (* rule F9 *)
    ( match f with
        true, (Believes(z_p, Fresh(Encrypt_priv(z_x, z_k)))) ->
          ( try  let proof2 = in_pool old (false,Believes(z_p, Recognizable(z_x)))
                 and proof3 = in_pool old (false,Believes(z_p, Fresh(Private_key(z_k))))
                 and proof4 = in_pool old (false,Possesses(z_p, Private_key(z_k))) in
            [((false,Believes(z_p, Fresh(Encrypt_priv(z_x, z_k)))), Rule("F9", [proof1; proof2; proof3; proof4]))]
            with Not_found -> []
          )
      | _ -> []
    )
    @

    (* rule F9b *)
    ( match f with
        true, (Believes(z_p, Fresh(Encrypt_priv(z_x, z_k)))) ->
          [((true,Believes(z_p, Recognizable(z_x))), Rule("F9b", [proof1]));
          ((true,Believes(z_p, Fresh(Private_key(z_k)))), Rule("F9b", [proof1]));
          ((true,Possesses(z_p, Private_key(z_k))), Rule("F9b", [proof1]))]
      | _ -> []
    )
    @

    (* rule F10 *)
    ( match f with
        true, (Believes(z_p, Fresh(Unary_func(z_h,z_x)))) ->
          ( try  let proof2 = in_pool old (false,Believes(z_p, Fresh(z_x)))
                 and proof3 = in_pool old (false,Possesses(z_p, z_x)) in
            [((false,Believes(z_p, Fresh(Unary_func(z_h,z_x)))), Rule("F10", [proof1; proof2; proof3]))]
            with Not_found -> []
          )
      | _ -> []
    )
    @

    (* rule F10b *)
    ( match f with
        true, (Believes(z_p, Fresh(Unary_func(z_h,z_x)))) ->
          [((true,Believes(z_p, Fresh(z_x))), Rule("F10b", [proof1]));
          ((true,Possesses(z_p, z_x)), Rule("F10b", [proof1]))]
      | _ -> []
    )
    @

    (* rule F11 *)
    ( match f with
        false, (Believes(z_p, Fresh(Unary_func(z_h,z_x)))) ->
          ( try  let proof2 = in_pool old (false,Possesses(z_p, Unary_func(z_h,z_x))) in
            [((false,Believes(z_p, Fresh(z_x))), Rule("F11", [proof1; proof2]))]
            with Not_found -> []
          )
      | _ -> []
    )
    @

    (* rule F11t *)
    ( match f with
        false, (Believes(z_p, Fresh(Unary_func(z_h,z_x)))) ->
          [((true,Possesses(z_p, Unary_func(z_h,z_x))), Rule("F11t", [proof1]))]
      | _ -> []
    )
    @

    (* rule R1 *)
    ( match f with
        true, (Believes(z_p, Recognizable(Pair(z_x, z_y)))) ->
          ( try  let proof2 = in_pool old (false,Believes(z_p, Recognizable(z_x))) in
            [((false,Believes(z_p, Recognizable(Pair(z_x, z_y)))), Rule("R1", [proof1; proof2]))]
            with Not_found -> []
          )
      | _ -> []
    )
    @

    (* rule R1b *)
    ( match f with
        true, (Believes(z_p, Recognizable(Pair(z_x, z_y)))) ->
          [((true,Believes(z_p, Recognizable(z_x))), Rule("R1b", [proof1]))]
      | _ -> []
    )
    @

    (* rule R1 *)
    ( match f with
        true, (Believes(z_p, Recognizable(Pair(z_y, z_x)))) ->
          ( try  let proof2 = in_pool old (false,Believes(z_p, Recognizable(z_x))) in
            [((false,Believes(z_p, Recognizable(Pair(z_y, z_x)))), Rule("R1", [proof1; proof2]))]
            with Not_found -> []
          )
      | _ -> []
    )
    @

    (* rule R1b *)
    ( match f with
        true, (Believes(z_p, Recognizable(Pair(z_y, z_x)))) ->
          [((true,Believes(z_p, Recognizable(z_x))), Rule("R1b", [proof1]))]
      | _ -> []
    )
    @

    (* rule R1 *)
    ( match f with
        true, (Believes(z_p, Recognizable(Unary_func(z_f,z_x)))) ->
          ( try  let proof2 = in_pool old (false,Believes(z_p, Recognizable(z_x))) in
            [((false,Believes(z_p, Recognizable(Unary_func(z_f,z_x)))), Rule("R1", [proof1; proof2]))]
            with Not_found -> []
          )
      | _ -> []
    )
    @

    (* rule R1b *)
    ( match f with
        true, (Believes(z_p, Recognizable(Unary_func(z_f,z_x)))) ->
          [((true,Believes(z_p, Recognizable(z_x))), Rule("R1b", [proof1]))]
      | _ -> []
    )
    @

    (* rule R2 *)
    ( match f with
        true, (Believes(z_p, Recognizable(Encrypt_s(z_x, z_k)))) ->
          ( try  let proof2 = in_pool old (false,Believes(z_p, Recognizable(z_x)))
                 and proof3 = in_pool old (false,Possesses(z_p, z_k)) in
            [((false,Believes(z_p, Recognizable(Encrypt_s(z_x, z_k)))), Rule("R2", [proof1; proof2; proof3]))]
            with Not_found -> []
          )
      | _ -> []
    )
    @

    (* rule R2b *)
    ( match f with
        true, (Believes(z_p, Recognizable(Encrypt_s(z_x, z_k)))) ->
          [((true,Believes(z_p, Recognizable(z_x))), Rule("R2b", [proof1]));
          ((true,Possesses(z_p, z_k)), Rule("R2b", [proof1]))]
      | _ -> []
    )
    @

    (* rule R2 *)
    ( match f with
        true, (Believes(z_p, Recognizable(Decrypt_s(z_x, z_k)))) ->
          ( try  let proof2 = in_pool old (false,Believes(z_p, Recognizable(z_x)))
                 and proof3 = in_pool old (false,Possesses(z_p, z_k)) in
            [((false,Believes(z_p, Recognizable(Decrypt_s(z_x, z_k)))), Rule("R2", [proof1; proof2; proof3]))]
            with Not_found -> []
          )
      | _ -> []
    )
    @

    (* rule R2b *)
    ( match f with
        true, (Believes(z_p, Recognizable(Decrypt_s(z_x, z_k)))) ->
          [((true,Believes(z_p, Recognizable(z_x))), Rule("R2b", [proof1]));
          ((true,Possesses(z_p, z_k)), Rule("R2b", [proof1]))]
      | _ -> []
    )
    @

    (* rule R2' *)
    ( match f with
        false, (Believes(z_p, Recognizable(Encrypt_s(z_x, z_k)))) ->
          ( try  let proof2 = in_pool old (false,Possesses(z_p, z_k)) in
            [((false,Believes(z_p, Recognizable(z_x))), Rule("R2'", [proof1; proof2]))]
            with Not_found -> []
          )
      | _ -> []
    )
    @

    (* rule R2't *)
    ( match f with
        false, (Believes(z_p, Recognizable(Encrypt_s(z_x, z_k)))) ->
          [((true,Possesses(z_p, z_k)), Rule("R2't", [proof1]))]
      | _ -> []
    )
    @

    (* rule R3 *)
    ( match f with
        true, (Believes(z_p, Recognizable(Encrypt_pub(z_x, z_k)))) ->
          ( try  let proof2 = in_pool old (false,Believes(z_p, Recognizable(z_x)))
                 and proof3 = in_pool old (false,Possesses(z_p, Public_key(z_k))) in
            [((false,Believes(z_p, Recognizable(Encrypt_pub(z_x, z_k)))), Rule("R3", [proof1; proof2; proof3]))]
            with Not_found -> []
          )
      | _ -> []
    )
    @

    (* rule R3b *)
    ( match f with
        true, (Believes(z_p, Recognizable(Encrypt_pub(z_x, z_k)))) ->
          [((true,Believes(z_p, Recognizable(z_x))), Rule("R3b", [proof1]));
          ((true,Possesses(z_p, Public_key(z_k))), Rule("R3b", [proof1]))]
      | _ -> []
    )
    @

    (* rule R4 *)
    ( match f with
        true, (Believes(z_p, Recognizable(Encrypt_priv(z_x, z_k)))) ->
          ( try  let proof2 = in_pool old (false,Believes(z_p, Recognizable(z_x)))
                 and proof3 = in_pool old (false,Possesses(z_p, Private_key(z_k))) in
            [((false,Believes(z_p, Recognizable(Encrypt_priv(z_x, z_k)))), Rule("R4", [proof1; proof2; proof3]))]
            with Not_found -> []
          )
      | _ -> []
    )
    @

    (* rule R4b *)
    ( match f with
        true, (Believes(z_p, Recognizable(Encrypt_priv(z_x, z_k)))) ->
          [((true,Believes(z_p, Recognizable(z_x))), Rule("R4b", [proof1]));
          ((true,Possesses(z_p, Private_key(z_k))), Rule("R4b", [proof1]))]
      | _ -> []
    )
    @

    (* rule R4' *)
    ( match f with
        false, (Believes(z_p, Recognizable(Encrypt_pub(z_x, z_k)))) ->
          ( try  let proof2 = in_pool old (false,Possesses(z_p, Private_key(z_k))) in
            [((false,Believes(z_p, Recognizable(z_x))), Rule("R4'", [proof1; proof2]))]
            with Not_found -> []
          )
      | _ -> []
    )
    @

    (* rule R4't *)
    ( match f with
        false, (Believes(z_p, Recognizable(Encrypt_pub(z_x, z_k)))) ->
          [((true,Possesses(z_p, Private_key(z_k))), Rule("R4't", [proof1]))]
      | _ -> []
    )
    @

    (* rule R5 *)
    ( match f with
        true, (Believes(z_p, Recognizable(Unary_func(z_h,z_x)))) ->
          ( try  let proof2 = in_pool old (false,Believes(z_p, Recognizable(z_x)))
                 and proof3 = in_pool old (false,Possesses(z_p, z_x)) in
            [((false,Believes(z_p, Recognizable(Unary_func(z_h,z_x)))), Rule("R5", [proof1; proof2; proof3]))]
            with Not_found -> []
          )
      | _ -> []
    )
    @

    (* rule R5b *)
    ( match f with
        true, (Believes(z_p, Recognizable(Unary_func(z_h,z_x)))) ->
          [((true,Believes(z_p, Recognizable(z_x))), Rule("R5b", [proof1]));
          ((true,Possesses(z_p, z_x)), Rule("R5b", [proof1]))]
      | _ -> []
    )
    @

    (* rule R6 *)
    ( match f with
        false, (Possesses(z_p, Unary_func(z_h,z_x))) ->
          [((false,Believes(z_p, Recognizable(z_x))), Rule("R6", [proof1]))]
      | _ -> []
    )
    @

    (* rule R6t *)
    ( match f with
        false, (Possesses(z_p, Unary_func(z_h,z_x))) ->
          []
      | _ -> []
    )
    @

    (* rule I1 *)
    ( match f with
        false, (Is_told(z_p, Not_originated_here(Encrypt_s(z_x, z_k)))) ->
          walk_pool old
            (function proof2 -> function
                false, (Believes(z_p_3, Is_secret(z_p_2, z_q, z_k_2))) when z_p=z_p_2 && z_p=z_p_3 && z_k=z_k_2 ->
                  ( try  let proof3 = in_pool old (false,Possesses(z_p, z_k))
                         and proof4 = in_pool old (false,Believes(z_p, Recognizable(z_x)))
                         and proof5 = in_pool old (false,Believes(z_p, Fresh(Pair(z_x, z_k)))) in
                    [((false,Believes(z_p, Once_conveyed(z_q, z_x))), Rule("I1", [proof1; proof2; proof3; proof4; proof5]));
                    ((false,Believes(z_p, Once_conveyed(z_q, Encrypt_s(z_x, z_k)))), Rule("I1", [proof1; proof2; proof3; proof4; proof5]));
                    ((false,Believes(z_p, Possesses(z_q, z_k))), Rule("I1", [proof1; proof2; proof3; proof4; proof5]))]
                    with Not_found -> []
                  )
              | _ -> []
            )
      | _ -> []
    )
    @

    (* rule I1t *)
    ( match f with
        false, (Is_told(z_p, Not_originated_here(Encrypt_s(z_x, z_k)))) ->
          walk_pool old
            (function proof2 -> function
                false, (Believes(z_p_3, Is_secret(z_p_2, z_q, z_k_2))) when z_p=z_p_2 && z_p=z_p_3 && z_k=z_k_2 ->
                  [((true,Possesses(z_p, z_k)), Rule("I1t", [proof1; proof2]));
                  ((true,Believes(z_p, Recognizable(z_x))), Rule("I1t", [proof1; proof2]));
                  ((true,Believes(z_p, Fresh(Pair(z_x, z_k)))), Rule("I1t", [proof1; proof2]))]
              | _ -> []
            )
      | _ -> []
    )
    @

    (* rule I2 *)
    ( match f with
        false, (Is_told(z_p, Not_originated_here(Encrypt_pub(Pair(z_x, z_s), z_k)))) ->
          walk_pool old
            (function proof2 -> function
                false, (Believes(z_p_3, Is_secret(z_p_2, z_q, z_s_2))) when z_s=z_s_2 && z_p=z_p_2 && z_p=z_p_3 ->
                  ( try  let proof3 = in_pool old (false,Possesses(z_p, Pair(Private_key(z_k), z_s)))
                         and proof4 = in_pool old (false,Believes(z_p, Is_public_key(z_p, z_k)))
                         and proof5 = in_pool old (false,Believes(z_p, Recognizable(Pair(z_x, z_s))))
                         and proof6 = in_pool old (false,Believes(z_p, Fresh(Pair(z_x, Pair(z_s, Public_key(z_k)))))) in
                    [((false,Believes(z_p, Once_conveyed(z_q, Pair(z_x, z_s)))), Rule("I2", [proof1; proof2; proof3; proof4; proof5; proof6]));
                    ((false,Believes(z_p, Once_conveyed(z_q, Encrypt_pub(Pair(z_x, z_s), z_k)))), Rule("I2", [proof1; proof2; proof3; proof4; proof5; proof6]));
                    ((false,Believes(z_p, Possesses(z_q, Public_key(z_k)))), Rule("I2", [proof1; proof2; proof3; proof4; proof5; proof6]))]
                    with Not_found -> []
                  )
              | _ -> []
            )
      | _ -> []
    )
    @

    (* rule I2t *)
    ( match f with
        false, (Is_told(z_p, Not_originated_here(Encrypt_pub(Pair(z_x, z_s), z_k)))) ->
          walk_pool old
            (function proof2 -> function
                false, (Believes(z_p_3, Is_secret(z_p_2, z_q, z_s_2))) when z_s=z_s_2 && z_p=z_p_2 && z_p=z_p_3 ->
                  [((true,Possesses(z_p, Pair(Private_key(z_k), z_s))), Rule("I2t", [proof1; proof2]));
                  ((true,Believes(z_p, Is_public_key(z_p, z_k))), Rule("I2t", [proof1; proof2]));
                  ((true,Believes(z_p, Recognizable(Pair(z_x, z_s)))), Rule("I2t", [proof1; proof2]));
                  ((true,Believes(z_p, Fresh(Pair(z_x, Pair(z_s, Public_key(z_k)))))), Rule("I2t", [proof1; proof2]))]
              | _ -> []
            )
      | _ -> []
    )
    @

    (* rule I3 *)
    ( match f with
        false, (Is_told(z_p, Not_originated_here(Binary_func(z_h,z_x, z_s)))) ->
          walk_pool old
            (function proof2 -> function
                false, (Believes(z_p_3, Is_secret(z_p_2, z_q, z_s_2))) when z_s=z_s_2 && z_p=z_p_2 && z_p=z_p_3 ->
                  ( try  let proof3 = in_pool old (false,Possesses(z_p, Pair(z_x, z_s)))
                         and proof4 = in_pool old (false,Believes(z_p, Fresh(Pair(z_x, z_s)))) in
                    [((false,Believes(z_p, Once_conveyed(z_q, Pair(z_x, z_s)))), Rule("I3", [proof1; proof2; proof3; proof4]));
                    ((false,Believes(z_p, Once_conveyed(z_q, Binary_func(z_h,z_x, z_s)))), Rule("I3", [proof1; proof2; proof3; proof4]))]
                    with Not_found -> []
                  )
              | _ -> []
            )
      | _ -> []
    )
    @

    (* rule I3t *)
    ( match f with
        false, (Is_told(z_p, Not_originated_here(Binary_func(z_h,z_x, z_s)))) ->
          walk_pool old
            (function proof2 -> function
                false, (Believes(z_p_3, Is_secret(z_p_2, z_q, z_s_2))) when z_s=z_s_2 && z_p=z_p_2 && z_p=z_p_3 ->
                  [((true,Possesses(z_p, Pair(z_x, z_s))), Rule("I3t", [proof1; proof2]));
                  ((true,Believes(z_p, Fresh(Pair(z_x, z_s)))), Rule("I3t", [proof1; proof2]))]
              | _ -> []
            )
      | _ -> []
    )
    @

    (* rule I4 *)
    ( match f with
        false, (Is_told(z_p, Encrypt_priv(z_x, z_k))) ->
          walk_pool old
            (function proof2 -> function
                false, (Believes(z_p_2, Is_public_key(z_q, z_k_2))) when z_p=z_p_2 && z_k=z_k_2 ->
                  ( try  let proof3 = in_pool old (false,Possesses(z_p, Public_key(z_k)))
                         and proof4 = in_pool old (false,Believes(z_p, Recognizable(z_x))) in
                    [((false,Believes(z_p, Once_conveyed(z_q, z_x))), Rule("I4", [proof1; proof2; proof3; proof4]));
                    ((false,Believes(z_p, Once_conveyed(z_q, Encrypt_priv(z_x, z_k)))), Rule("I4", [proof1; proof2; proof3; proof4]))]
                    with Not_found -> []
                  )
              | _ -> []
            )
      | _ -> []
    )
    @

    (* rule I4t *)
    ( match f with
        false, (Is_told(z_p, Encrypt_priv(z_x, z_k))) ->
          walk_pool old
            (function proof2 -> function
                false, (Believes(z_p_2, Is_public_key(z_q, z_k_2))) when z_p=z_p_2 && z_k=z_k_2 ->
                  [((true,Possesses(z_p, Public_key(z_k))), Rule("I4t", [proof1; proof2]));
                  ((true,Believes(z_p, Recognizable(z_x))), Rule("I4t", [proof1; proof2]))]
              | _ -> []
            )
      | _ -> []
    )
    @

    (* rule I5 *)
    ( match f with
        false, (Is_told(z_p, Encrypt_priv(z_x, z_k))) ->
          walk_pool old
            (function proof2 -> function
                false, (Believes(z_p_2, Is_public_key(z_q, z_k_2))) when z_p=z_p_2 && z_k=z_k_2 ->
                  ( try  let proof3 = in_pool old (false,Possesses(z_p, Public_key(z_k)))
                         and proof4 = in_pool old (false,Believes(z_p, Recognizable(z_x)))
                         and proof5 = in_pool old (false,Believes(z_p, Fresh(Pair(z_x, Public_key(z_k))))) in
                    [((false,Believes(z_p, Possesses(z_q, Pair(Private_key(z_k), z_x)))), Rule("I5", [proof1; proof2; proof3; proof4; proof5]))]
                    with Not_found -> []
                  )
              | _ -> []
            )
      | _ -> []
    )
    @

    (* rule I5t *)
    ( match f with
        false, (Is_told(z_p, Encrypt_priv(z_x, z_k))) ->
          walk_pool old
            (function proof2 -> function
                false, (Believes(z_p_2, Is_public_key(z_q, z_k_2))) when z_p=z_p_2 && z_k=z_k_2 ->
                  [((true,Possesses(z_p, Public_key(z_k))), Rule("I5t", [proof1; proof2]));
                  ((true,Believes(z_p, Recognizable(z_x))), Rule("I5t", [proof1; proof2]));
                  ((true,Believes(z_p, Fresh(Pair(z_x, Public_key(z_k))))), Rule("I5t", [proof1; proof2]))]
              | _ -> []
            )
      | _ -> []
    )
    @

    (* rule I6 *)
    ( match f with
        false, (Believes(z_p, Once_conveyed(z_q, z_x))) ->
          ( try  let proof2 = in_pool old (false,Believes(z_p, Fresh(z_x))) in
            [((false,Believes(z_p, Possesses(z_q, z_x))), Rule("I6", [proof1; proof2]))]
            with Not_found -> []
          )
      | _ -> []
    )
    @

    (* rule I6t *)
    ( match f with
        false, (Believes(z_p, Once_conveyed(z_q, z_x))) ->
          [((true,Believes(z_p, Fresh(z_x))), Rule("I6t", [proof1]))]
      | _ -> []
    )
    @

    (* rule I7 *)
    ( match f with
        false, (Believes(z_p, Once_conveyed(z_q, Pair(z_x, z_y)))) ->
          [((false,Believes(z_p, Once_conveyed(z_q, z_x))), Rule("I7", [proof1]));
          ((false,Believes(z_p, Once_conveyed(z_q, z_y))), Rule("I7", [proof1]))]
      | _ -> []
    )
    @

    (* rule I7t *)
    ( match f with
        false, (Believes(z_p, Once_conveyed(z_q, Pair(z_x, z_y)))) ->
          []
      | _ -> []
    )
    @

    (* rule J1 *)
    ( match f with
        false, (Believes(z_p, Jurisdiction(z_q,z_c))) ->
          ( try  let proof2 = in_pool old (false,Believes(z_p, Believes(z_q, z_c))) in
            [((false,Believes(z_p, z_c)), Rule("J1", [proof1; proof2]))]
            with Not_found -> []
          )
      | _ -> []
    )
    @

    (* rule J1t *)
    ( match f with
        false, (Believes(z_p, Jurisdiction(z_q,z_c))) ->
          [((true,Believes(z_p, Believes(z_q, z_c))), Rule("J1t", [proof1]))]
      | _ -> []
    )
    @

    (* rule J2 *)
    ( match f with
        false, (Believes(z_p, Once_conveyed(z_q, Leading_to(z_x, z_c)))) ->
          ( try  let proof2 = in_pool old (false,Believes(z_p, Honest_and_competent(z_q))) in
            [((false,Believes(z_p, Believes(z_q, z_c))), Rule("J2", [proof1; proof2]))]
            with Not_found -> []
          )
      | _ -> []
    )
    @

    (* rule J2t *)
    ( match f with
        false, (Believes(z_p, Once_conveyed(z_q, Leading_to(z_x, z_c)))) ->
          [((true,Believes(z_p, Honest_and_competent(z_q))), Rule("J2t", [proof1]))]
      | _ -> []
    )
    @

    (* rule J3 *)
    ( match f with
        false, (Believes(z_p, Believes(z_q_2, Believes(z_q, z_c)))) when z_q=z_q_2 ->
          ( try  let proof2 = in_pool old (false,Believes(z_p, Honest_and_competent(z_q))) in
            [((false,Believes(z_p, Believes(z_q, z_c))), Rule("J3", [proof1; proof2]))]
            with Not_found -> []
          )
      | _ -> []
    )
    @

    (* rule J3t *)
    ( match f with
        false, (Believes(z_p, Believes(z_q_2, Believes(z_q, z_c)))) when z_q=z_q_2 ->
          [((true,Believes(z_p, Honest_and_competent(z_q))), Rule("J3t", [proof1]))]
      | _ -> []
    )

    @

    (* rationality rule*)
    ( match f with
        flag, (Believes(p, x)) ->
          List.map (fun ((flag,x),proof) -> (flag, Believes(p, x)), proof)
            (apply_rules_r
              (Gny_prime_map.fold
                (fun (flag,f) pr s ->
		  match f with
                    Believes(p2, x) when p2=p ->
                      Gny_prime_map.add (flag,x) pr s
                  | _ -> s
                ) old
              Gny_prime_map.empty) proof1 (flag,x))
      | _ -> []
    )
  );;

let apply_rules (old : proof Gny_prime_map.t) =
  walk_pool old (apply_rules_r old);;
