type gny =
    Is_told of principal*gny
  | Possesses of principal*gny
  | Once_conveyed of principal*gny
  | Believes of principal*gny
  | Fresh of gny
  | Recognizable of gny
  | Is_secret of principal*principal*gny
  | Is_public_key of principal*pkey_id
  | Encrypt_pub of gny*pkey_id
  | Encrypt_priv of gny*pkey_id
  | Encrypt_s of gny*gny
  | Decrypt_s of gny*gny
  | Unary_func of function_id*gny
  | Binary_func of function_id*gny*gny
  | Variable of variable_id
  | Public_key of pkey_id
  | Private_key of pkey_id
  | Pair of gny*gny
  | Not_originated_here of gny
  | Honest_and_competent of principal
  | Jurisdiction of principal * gny
  | Leading_to of gny * gny

and principal=string
and pkey_id=string
and variable_id=string
and function_id=string;;

type gny_prime = bool*gny;;

type gny_prime_rule =
  { name                : string;
    matching_hypotheses : gny_prime list;
    other_hypotheses    : gny_prime list;
    conclusions         : gny_prime list };;

type hypothesis_id = string
and rule_id = string;;

type proof=gny_prime*proof_type
and proof_type =
    Hypothesis of hypothesis_id
  | Rule of rule_id*(proof list);;

